//MOOD LAMP - MANUFACTURA DIGITAL Javier Aguilar - 20283

#include <Adafruit_NeoPixel.h>

//Neopixels y Micrófono
#define PIN        11
#define NUMPIXELS   7
#define MIC A0
#define N 100
#define fadeDelay 10
#define noiseLevel 15

Adafruit_NeoPixel neos(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);


//Variables para los potenciómetros
const int RedPOT = A1;
const int GreenPOT = A2;
const int BluePOT = A3;
int red;
int green;
int blue;

//Variables para el botón
const int btn_pin = 4;
int btn_state;
int instante;
int modo = 1;

//Variables para conversión de sonido a movimiento de luces
unsigned long lastDebounceTime = 0;  
unsigned long debounceDelay = 25; 
int samples[N]; 
int periodFactor = 0; 
int t1 = -1; 
int T; 
int slope; 
byte periodChanged = 0;


void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  neos.begin();
  neos.show();
  pinMode(btn_pin,INPUT);

}

void loop() {
  // put your main code here, to run repeatedly:
  neos.clear();
  btn_state = digitalRead(btn_pin);

  if((instante == LOW) && (btn_state == HIGH)) {
    if(modo == 1) {
      modo = 0;
    }
    else{
      modo = 1;
    }
}
instante = btn_state;

if(modo == 1){
 red = analogRead (RedPOT) / 4;       //convertir valor de potrniómetro a un valor legible para las neopixels entre 0 y 255
 green = analogRead (GreenPOT) / 4;
 blue = analogRead (BluePOT) / 4;

 neos.setPixelColor(0, neos.Color(red, green, blue));
 neos.setPixelColor(1, neos.Color(red, green, blue));
 neos.setPixelColor(2, neos.Color(red, green, blue));
 neos.setPixelColor(3, neos.Color(red, green, blue));
 neos.setPixelColor(4, neos.Color(red, green, blue));
 neos.setPixelColor(5, neos.Color(red, green, blue));
 neos.setPixelColor(6, neos.Color(red, green, blue));
 neos.show(); 
 delay(0);
 
}

else{
  Automatico();
}
instante = btn_state;
}

void Automatico() {  //Las funciones que convierten el sonido a instrucciones para las neopixels fueron obtenidas de Nematic! en instructables 
  for(int i=0; i<N; i++) {
    samples[i] = analogRead(0);
    if(i>0) {
      slope = samples[i] - samples[i-1];
    }
    else {
      slope = samples[i] - samples[N-1];
    }
    
    if(abs(slope) > noiseLevel) {    // el sonido captado por el micrófono tiene que ser mayor a el soniedo ambiental para activar las funciones de las luces
      if(slope < 0) {
        calculatePeriod(i);
        if(periodChanged == 1) {
          displayColor(getColor(T));
        }
      }
    }
    else {
      ledsOff();
    }
    periodFactor += 1;
    delay(1);
  }
}

void calculatePeriod(int i) {  // calcula el periodo
  if(t1 == -1) {
  
    t1 = i;
  }
  else {
    
    int period = periodFactor*(i - t1);
    periodChanged = T==period ? 0 : 1;
    T = period;   
    t1 = i;
    periodFactor = 0;
  }
}

uint32_t getColor(int period) {   //se determina el color
  if(period == -1)
    return Wheel(0);
  else if(period > 400)
    return Wheel(5);
  else
    return Wheel(map(-1*period, -400, -1, 50, 255));
}

void fadeOut()    // la transición y cuánto se desvanece entre los colores
{
  for(int i=0; i<5; i++) {
    neos.setBrightness(110 - i*20);
    neos.show(); // Update strip
    delay(fadeDelay);
    periodFactor +=fadeDelay;
  }
}

void fadeIn() {
  neos.setBrightness(100);
  neos.show();

  for(int i=0; i<5; i++) {
    //strip.setBrightness(20*i + 30);
    //strip.show();
    delay(fadeDelay);
    periodFactor+=fadeDelay;
  }
}

void ledsOff() {   // en caso no se supere el threshold de sonido ambiental no se prenden las luces
  fadeOut();
  for(int i=0; i<NUMPIXELS; i++) {
    neos.setPixelColor(i, 0, 0, 0);
  }
}

void displayColor(uint32_t color) {  //Instrucción específica de prender los colores. 
  for(int i=0; i<NUMPIXELS; i++) {
    neos.setPixelColor(i, color);
  }
  fadeIn();
}


uint32_t Wheel(byte WheelPos) {   //Determinación del color según la wheel.
  // Serial.println(WheelPos);
  if(WheelPos < 85) {
   
    return neos.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  } 
  else if(WheelPos < 170) {
    WheelPos -= 85;
    return neos.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } 
  else {
    WheelPos -= 170;
    return neos.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
}
